// $Id: xml.h 5417 2007-12-06 12:05:42Z jz $        Joacim Zschimmer, Zschimmer GmbH, http://www.zschimmer.com

#ifndef __ZSCHIMMER_XML_H
#define __ZSCHIMMER_XML_H

#include "z_io.h"


#define DOM_FOR_EACH_ELEMENT( PARENT, ITERATOR )                                                \
                                                                                                \
    for( ::zschimmer::xml::libxml2::Simple_node_ptr ITERATOR##_node = (PARENT).firstChild();    \
         ITERATOR##_node;                                                                       \
         ITERATOR##_node = ITERATOR##_node.nextSibling() )                                      \
                                                                                                \
    if( ::zschimmer::xml::libxml2::Element_ptr ITERATOR = xml::Element_ptr( ITERATOR##_node, ::zschimmer::xml::libxml2::Element_ptr::no_xc ) )


namespace zschimmer {
namespace xml {


namespace libxml2
{
    struct Element_ptr;
}


//-------------------------------------------------------------------------------------------------

string                          encode_text                 ( const string&, bool quote_too = false );
inline string                   encode_attribute_value      ( const string& value )                 { return encode_text( value, true ); }

//---------------------------------------------------------------------------------------Xml_writer

struct Xml_writer : io::Filter_writer
{
                                Xml_writer                  ( Writer* );

    void                    set_encoding                    ( const string& encoding )              { _encoding = encoding; }                                   
    void                        write_prolog                ();

    void                        begin_element               ( const string& element_name );
    void                        set_attribute               ( const string& name, const string& );
    void                        set_attribute               ( const string& name, int64 );
    void                        set_attribute_optional      ( const string& name, const string& );
    void                        end_element                 ( const string& element_name );

    void                        write                       ( const io::Char_sequence& utf8_text );
    void                        write_through               ( const io::Char_sequence& text );
    void                        flush                       ();

    void                        write_element               ( const libxml2::Element_ptr& );

  protected:
    void                        close_tag                   ();

  private:
    bool                       _is_tag_open;
    string                     _encoding;
};

//-------------------------------------------------------------------------------------------------

} //namespace xml
} //namespace zschimmer

#endif
