// $Id: z_posix_process.h 5353 2007-10-22 15:01:57Z jz $

#ifndef __ZSCHIMMER_WINDOWS_PROCESS_H
#define __ZSCHIMMER_WINDOWS_PROCESS_H


#include "z_posix.h"
#include <signal.h>             // SIGKILL


namespace zschimmer {
namespace posix {

//-------------------------------------------------------------------------------------------------
    
std::vector<string>             argv_from_command_line      ( const string& command_line );
//string                          shell_command_line_from_argv( int argc, char** argv );              // Erstmal nur zur Debug-Ausgabe
string                          shell_command_line_from_argv( const std::vector<string>& );         // Erstmal nur zur Debug-Ausgabe
int                             priority_from_string        ( const string& );
int                             z_clearenv                  ();

//------------------------------------------------------------------------------------------Process

struct Process : Process_base
{
                                Process                     ();
                                Process                     ( int pid )                             : _zero_(this+1) { attach_pid( pid ); }
    virtual                    ~Process                     ();

    void                        close                       ();                                
    void                        start                       ( const string& command );
    void                        start                       ( const std::vector<string>& command );
    void                        attach_pid                  ( int pid )                             { close();  _pid = pid; }
    bool                    set_priority                    ( int ); //, Has_log* = NULL );
    int                         priority                    ();
    bool                    set_priority_class              ( const string& ); //, Has_log* = NULL );
    string                      priority_class              ();
  //bool                        raise_priority              ( int difference );
    void                        wait                        ();
    bool                        wait                        ( double seconds );
    bool                        terminated                  ();
    int                         exit_code                   ();
    int                         termination_signal          ();
    void                        kill                        ( int signal = SIGKILL );
    bool                        try_kill                    ( int signal = SIGKILL );
    bool                        opened                      () const                                { return _working_pid != 0; }
  //string                      obj_name                    () const;


  private:
    bool                        call_waitpid                ( bool wait );


    Fill_zero                  _zero_;
    int                        _working_pid;
    int                        _exit_code;
    int                        _termination_signal;
    
    bool                       _priority_set;
    int                        _priority;
  //bool                       _raise_priority_set;
  //int                        _raise_priority;
};

//-------------------------------------------------------------------------------------------------

} //namespace posix
} //namespace zschimmer

#endif
